declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Inbound Target Event - latest Sync';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'select t.target as TARGET,
'||'       t.code as ACCOUNT_USERID,
'||'       t.functionality as PERMISSION_NAME,
'||'       case
'||'         when t.operation = ''1'' then ''PERMISSION TO BE REMOVED FROM TARGET''
'||'         when t.operation = ''2'' then ''PERMISSION TO BE ADDED ON TARGET''
'||'         when t.operation = ''6'' then ''ACCOUNT TO BE ENABLED ON TARGET''
'||'         when t.operation = ''7'' then ''ACCOUNT TO BE DISABLED ON TARGET''
'||'         when t.operation = ''10'' then ''ACCOUNT TO BE REMOVED FROM TARGET''
'||'         when t.operation = ''11'' then ''ACCOUNT TO BE ADDED ON TARGET''
'||'         else ''UNKNOWN''
'||'       end as MESSAGE,
'||'       case
'||'         when substr(t.trace,22)=''Changes in IDEAS Disabled!'' then ''''
'||'         else substr(t.trace,22)
'||'       end as TRACE,
'||'       t.process_id as RECONCILIATION_ID
'||'  from #pmschema#.event_target t
'||' where
'||'   t.operation<>6 and t.operation<>7 and
'||'   t.state = 2 and
'||'   lower(t.target) = lower(''#target_name#'') and
'||'   cast ( t.process_id as varchar ) =
'||'   (
'||'     select max ( cast ( process_id as varchar ) ) from #pmschema#.event_target
'||'     where lower(target)=lower(''#target_name#'')
'||'   )
'||' order by t.code asc, t.operation desc
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;