declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Reconciliation - Sync Status by Target';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'with ev_targ
'||'as
'||'(
'||'  select
'||'    t.id,
'||'    t.code,
'||'    t.operation,
'||'    t.state,
'||'    t.trace,
'||'    replace ( replace ( t.trace, ''java.lang.Exception: '', '''' ), ''[DBMSException]: '', '''' ) as trace_new,
'||'    t.target,
'||'    t.functionality,
'||'    t.functionality_type,
'||'    t.attr1,
'||'    t.attr2,
'||'    t.attr3,
'||'    t.attr4,
'||'    t.attr5,
'||'    t.date_event,
'||'    t.date_process,
'||'    t.ownership,
'||'    t.last_mod_user,
'||'    t.last_mod_time,
'||'    t.application,
'||'    t.priority,
'||'    t.process_id
'||'  from #pmschema#.event_target t
'||'  where cast ( t.process_id as varchar ) =
'||'  (
'||'    select max ( cast ( process_id as varchar ) )
'||'    from #pmschema#.event_target
'||'    where lower ( target ) = lower ( ''#target_name#'' )
'||'  )
'||'  and lower ( target ) = lower ( ''#target_name#'' )
'||')
'||'select vgtab.TARGET,
'||'       vgtab.NAME,
'||'       vgtab.SURNAME,
'||'       vgtab.OU_NAME,
'||'       vgtab.OU_CODE,
'||'       vgtab.ACCOUNT_USERID,
'||'       vgtab.PERMISSION_NAME,
'||'       vgtab.RIGHTS,
'||'       vgtab.MESSAGE,
'||'       vgtab.TRACE,
'||'       vgtab.STATUS
'||'from
'||'(
'||'   -- ACCOUNT RECONCILIATION : ACCOUNT TO REMOVE OR TO ADD
'||'   select t.target as TARGET,
'||'          p.name as NAME,
'||'          p.surname as SURNAME,
'||'          o.name as OU_NAME,
'||'          o.code as OU_CODE,
'||'          t.code as ACCOUNT_USERID,
'||'          '''' as PERMISSION_NAME,
'||'          '''' as RIGHTS,
'||'          case
'||'      when t.operation = ''10'' then ''ACCOUNT TO BE REMOVED FROM TARGET''
'||'      when t.operation = ''11'' then ''ACCOUNT TO BE ADDED ON TARGET''
'||'      end as MESSAGE,
'||'          case
'||'      when t.trace_new = ''Apply Changes in IDEAS Disabled!'' then ''''
'||'            else t.trace_new
'||'          end as TRACE,
'||'          t.process_id as RECONCILIATION_ID,
'||'          ''ACCOUNT OUT OF SYNC'' as STATUS
'||'   from  ev_targ t
'||'   full outer join #pmschema#.target tg on lower (t.target ) = lower (tg.name )
'||'   full outer join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'   full outer join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg and t.code = pwd.code
'||'   full outer join #pmschema#.person p on pwd.person = p.id
'||'   full outer join #pmschema#.organizational_unit o on p.organizational_unit = o.id
'||'    where t.operation in ( ''10'', ''11'' )
'||'      and t.state = 2
'||'          and t.trace_new like ''Apply Changes in IDEAS Disabled!''
'||'          and o.hierarchy = 1
'||'   union
'||'   -- ALL THE OTHER ACCOUNTS : IDEAS ACCOUNT MINUS ACCOUNTS TO REMOVE OR TO ADD
'||'   select distinct tg1.name as TARGET,
'||'                   p.name as NAME,
'||'                   p.surname as SURNAME,
'||'                   o.name as OU_NAME,
'||'                   o.code as OU_CODE,
'||'                   pwd1.code as ACCOUNT_USERID,
'||'                   '''' as PERMISSION_NAME,
'||'           '''' as RIGHTS,
'||'                   '''' as MESSAGE,
'||'                   '''' as TRACE,
'||'                   '''' as RECONCILIATION_ID,
'||'                   ''ACCOUNT IN SYNC'' as STATUS
'||'   from ev_targ tt
'||'   inner join #pmschema#.target tg1 on lower(tt.target) = lower(tg1.name)
'||'   inner join #pmschema#.pwdcfg pcfg1 on tg1.pwdcfg = pcfg1.id
'||'   inner join #pmschema#.pwdmanagement pwd1 on pcfg1.id = pwd1.pwdcfg
'||'   inner join #pmschema#.person p on pwd1.person = p.id
'||'   inner join #pmschema#.organizational_unit o on p.organizational_unit = o.id
'||'   where not exists (
'||'     select 1
'||'     from ev_targ t
'||'   full outer join #pmschema#.target tg on lower (t.target ) = lower (tg.name )
'||'   full outer join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'   full outer join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg and t.code = pwd.code
'||'     where t.operation in (''10'', ''11'')
'||'       and t.state = 2
'||'       and t.trace_new like ''Apply Changes in IDEAS Disabled!''
'||'       and t.code = pwd1.code)
'||'      and o.hierarchy = 1
'||'    union
'||'    -- PERMISSIONS RECONCILIATION : PERMISSION TO ADD OR TO REMOVE
'||'    select t.target as TARGET,
'||'        p.name as NAME,
'||'        p.surname as SURNAME,
'||'        o.name as OU_NAME,
'||'        o.code as OU_CODE,
'||'        t.code as ACCOUNT_USERID,
'||'        t.functionality as PERMISSION_NAME,
'||'        '''' as RIGHTS,
'||'        case
'||'         when t.operation = ''1'' then ''PERMISSION TO BE REMOVED FROM TARGET''
'||'         when t.operation = ''2'' then ''PERMISSION TO BE ADDED ON TARGET''
'||'        end as MESSAGE,
'||'        case
'||'         when t.trace_new = ''Apply Changes in IDEAS Disabled!'' then ''''
'||'         else t.trace_new
'||'        end as TRACE,
'||'        t.process_id as RECONCILIATION_ID,
'||'        ''PERMISSION OUT OF SYNC'' as STATUS
'||'    from ev_targ t
'||'    full outer join #pmschema#.target tg on lower (t.target) = lower (tg.name)
'||'    full outer join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'    full outer join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg and t.code = pwd.code
'||'    full outer join #pmschema#.person p on pwd.person = p.id
'||'    full outer join #pmschema#.organizational_unit o on p.organizational_unit = o.id
'||'    where t.operation in (''1'', ''2'')
'||'      and t.state = 2
'||'      and o.hierarchy = 1
'||'    union
'||'    -- ALL THE OTHER PERMISSIONS : PERMISSIONS IN IDEAS MINUS PERMISSIONS IN TARGET EVENTS
'||'    select distinct tg1.name as TARGET,
'||'            p.name as NAME,
'||'            p.surname as SURNAME,
'||'            ou.name as OU_NAME,
'||'            ou.code as OU_CODE,
'||'            pwd1.code as ACCOUNT_USERID,
'||'            ent.name as PERMISSION_NAME,
'||'      '''' as RIGHTS,
'||'            '''' as MESSAGE,
'||'            '''' as TRACE,
'||'            '''' as RECONCILIATION_ID,
'||'            ''PERMISSION IN SYNC'' as STATUS
'||'    from ev_targ tt
'||'    inner join #pmschema#.target tg1 on lower (tt.target) = lower (tg1.name)
'||'    inner join #pmschema#.pwdcfg pcfg1 on tg1.pwdcfg = pcfg1.id
'||'    inner join #pmschema#.pwdmanagement pwd1 on pcfg1.id = pwd1.pwdcfg
'||'    inner join #pmschema#.person p on pwd1.person = p.id
'||'    inner join #pmschema#.application app on tg1.id = app.target
'||'    inner join #pmschema#.organizational_unit ou on p.organizational_unit = ou.id
'||'    inner join #pmschema#.employment emp on p.id = emp.person
'||'    inner join #pmschema#.entitlement_flat_hier efh on emp.entitlement = efh.parent and efh.child_application = app.id and efh.child_int_type = 1
'||'    inner join #pmschema#.entitlement ent on efh.child = ent.id and efh.child_application = ent.application
'||'    where not exists (
'||'    select 1
'||'    from ev_targ t
'||'    full outer join #pmschema#.target tg on lower (t.target) = lower (tg.name)
'||'    full outer join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'    full outer join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg and t.code = pwd.code
'||'    where t.operation in (''1'', ''2'')
'||'      and t.state = 2
'||'      and t.functionality = ent.name
'||'      and t.code = pwd1.code)
'||'      and ou.hierarchy = 1
'||'      and ou.hierarchy = emp.hierarchy
'||'    union
'||'    -- RIGHTS RECONCILIATION : RIGHTS TO ADD OR TO REMOVE
'||'    select t.target as TARGET,
'||'        p.name as NAME,
'||'        p.surname as SURNAME,
'||'        o.name as OU_NAME,
'||'        o.code as OU_CODE,
'||'        t.code as ACCOUNT_USERID,
'||'        t.functionality as PERMISSION_NAME,
'||'        t.attr2 || '' - '' || t.attr3 as RIGHTS,
'||'        case
'||'         when t.operation = ''12'' then ''RIGHT TO BE REMOVED FROM TARGET''
'||'         when t.operation = ''13'' then ''RIGHT TO BE ADDED ON TARGET''
'||'        end as MESSAGE,
'||'        case
'||'         when t.trace_new = ''Apply Changes in IDEAS Disabled!'' then ''''
'||'         else t.trace_new
'||'        end as TRACE,
'||'        t.process_id as RECONCILIATION_ID,
'||'        ''RIGHT OUT OF SYNC'' as STATUS
'||'    from ev_targ t
'||'    full outer join #pmschema#.target tg on lower (t.target) = lower (tg.name)
'||'    full outer join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'    full outer join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg and t.code = pwd.code
'||'    full outer join #pmschema#.person p on pwd.person = p.id
'||'    full outer join #pmschema#.organizational_unit o on p.organizational_unit = o.id
'||'    where t.operation in (''12'', ''13'')
'||'      and t.state = 2
'||'      and o.hierarchy = 1
'||'    union
'||'    -- ALL THE OTHER RIGHTS : RIGHTS IN IDEAS MINUS RIGHTS IN TARGET EVENTS
'||'    select distinct tg1.name as TARGET,
'||'            p.name as NAME,
'||'            p.surname as SURNAME,
'||'            ou.name as OU_NAME,
'||'            ou.code as OU_CODE,
'||'            pwd1.code as ACCOUNT_USERID,
'||'            ent.name as PERMISSION_NAME,
'||'            ps.name || '' - '' || ps.value as RIGHTS,
'||'            '''' as MESSAGE,
'||'            '''' as TRACE,
'||'            '''' as RECONCILIATION_ID,
'||'            ''RIGHT IN SYNC'' as STATUS
'||'    from ev_targ tt
'||'    inner join #pmschema#.target tg1 on lower (tt.target) = lower (tg1.name)
'||'    inner join #pmschema#.pwdcfg pcfg1 on tg1.pwdcfg = pcfg1.id
'||'    inner join #pmschema#.pwdmanagement pwd1 on pcfg1.id = pwd1.pwdcfg
'||'    inner join #pmschema#.person p on pwd1.person = p.id
'||'    inner join #pmschema#.application app on tg1.id = app.target
'||'    inner join #pmschema#.organizational_unit ou on p.organizational_unit = ou.id
'||'    inner join #pmschema#.employment emp on p.id = emp.person
'||'    inner join #pmschema#.entitlement_flat_hier efh on emp.entitlement = efh.parent and efh.child_application = app.id and efh.child_int_type = 1
'||'    inner join #pmschema#.entitlement ent on efh.child = ent.id and efh.child_application = ent.application
'||'    inner join #pmschema#.person_service ps on ps.person = p.id and ps.profile = efh.child
'||'    where not exists (
'||'    select 1
'||'    from ev_targ t
'||'    full outer join #pmschema#.target tg on lower (t.target) = lower (tg.name)
'||'    full outer join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'    full outer join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg and t.code = pwd.code
'||'    full outer join #pmschema#.person p1 on pwd.person = p1.id
'||'    where t.operation in (''12'', ''13'')
'||'      and t.state = 2
'||'      and t.functionality = ent.name
'||'      and t.attr2 = ps.name
'||'      and t.attr3 = ps.value
'||'      and t.code = pwd1.code)
'||'    and ou.hierarchy = 1
'||'    and ou.hierarchy = emp.hierarchy
'||') vgtab
'||'order by
'||'       vgtab.ACCOUNT_USERID,
'||'       vgtab.NAME,
'||'       vgtab.SURNAME,
'||'       vgtab.STATUS,
'||'       vgtab.PERMISSION_NAME,
'||'       vgtab.RIGHTS
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;