declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Reconcilition Status - IDEAS as Master [Coarse Grain]';
  rq_desc          varchar2(512) := '';
  rqd              clob;

  counter          number(16);
begin
  rqd := 'with ev_targ
'||'as
'||'(
'||'  select
'||'    t.id,
'||'    t.code,
'||'    t.operation,
'||'    t.state,
'||'    t.trace,
'||'    replace ( replace ( t.trace, ''java.lang.Exception: '', '''' ), ''[DBMSException]: '', '''' ) as trace_new,
'||'    t.target,
'||'    t.functionality,
'||'    t.functionality_type,
'||'    t.attr1,
'||'    t.attr2,
'||'    t.attr3,
'||'    t.attr4,
'||'    t.attr5,
'||'    t.date_event,
'||'    t.date_process,
'||'    t.ownership,
'||'    t.last_mod_user,
'||'    t.last_mod_time,
'||'    t.application,
'||'    t.priority,
'||'    t.process_id
'||'  from #pmschema#.event_target t
'||'  where cast ( t.process_id as varchar ) =
'||'  (
'||'    select max ( cast ( process_id as varchar ) )
'||'    from #pmschema#.event_target
'||'    where lower ( target ) = lower ( ''#target_name#'' )
'||'  )
'||')
'||'select vgtab.TARGET,
'||'  vgtab.NAME,
'||'  vgtab.SURNAME,
'||'  vgtab.OU_NAME,
'||'  vgtab.OU_CODE,
'||'  vgtab.ACCOUNT_USERID,
'||'  vgtab.PERMISSION_NAME,
'||'  vgtab.MESSAGE,
'||'  vgtab.TRACE,
'||'  vgtab.STATUS
'||'from
'||'(
'||'    -- RECONCILIATION : ACCOUNT TO REMOVE OR TO ADD
'||'    select t.target as TARGET,
'||'        '''' as NAME,
'||'        '''' as SURNAME,
'||'        '''' as OU_NAME,
'||'        '''' as OU_CODE,
'||'        t.code as ACCOUNT_USERID,
'||'        t.functionality as PERMISSION_NAME,
'||'        case
'||'         when t.operation = ''10'' then ''ACCOUNT TO BE REMOVED FROM TARGET''
'||'         when t.operation = ''11'' then ''ACCOUNT TO BE ADDED ON TARGET''
'||'        end as MESSAGE,
'||'        t.trace_new as TRACE,
'||'        t.process_id as RECONCILIATION_ID,
'||'        ''ACCOUNT OUT OF SYNC'' as STATUS
'||'    from ev_targ t
'||'    where t.operation in ( ''10'', ''11'' )
'||'      and t.state = 2
'||'      --and t.trace_new like ''Unable%''
'||'      and not exists
'||'      (
'||'        select 1 from #pmschema#.target tg, #pmschema#.pwdcfg pcfg, #pmschema#.pwdmanagement pwd
'||'        where tg.pwdcfg = pcfg.id and pcfg.id = pwd.pwdcfg
'||'        and lower ( t.target ) = lower ( tg.name )
'||'        and lower ( pwd.code ) = lower ( t.code )
'||'      )
'||'    union
'||'    select t.target as TARGET,
'||'        p.name as NAME,
'||'        p.surname as SURNAME,
'||'        o.name as OU_NAME,
'||'        o.code as OU_CODE,
'||'        t.code as ACCOUNT_USERID,
'||'        t.functionality as PERMISSION_NAME,
'||'        case
'||'         when t.operation = ''10'' then ''ACCOUNT TO BE REMOVED FROM TARGET''
'||'         when t.operation = ''11'' then ''ACCOUNT TO BE ADDED ON TARGET''
'||'        end as MESSAGE,
'||'        case
'||'         when t.trace_new = ''Changes in IDEAS Disabled!'' then ''''
'||'         else t.trace_new
'||'        end as TRACE,
'||'        t.process_id as RECONCILIATION_ID,
'||'        ''ACCOUNT OUT OF SYNC'' as STATUS
'||'    from ev_targ t
'||'    inner join #pmschema#.target tg on lower ( t.target ) = lower ( tg.name )
'||'    inner join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'    inner join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg and t.code = pwd.code
'||'    inner join #pmschema#.person p on pwd.person = p.id
'||'    inner join #pmschema#.organizational_unit o on p.organizational_unit = o.id
'||'    where t.operation in ( ''10'', ''11'' )
'||'      and t.state = 2
'||'      --and t.trace_new not like ''Unable%''
'||'      and o.hierarchy = 1
'||'    union
'||'    -- RECONCILIATION : PERMISSION TO ADD OR TO REMOVE
'||'    select t.target as TARGET,
'||'        p.name as NAME,
'||'        p.surname as SURNAME,
'||'        o.name as OU_NAME,
'||'        o.code as OU_CODE,
'||'        t.code as ACCOUNT_USERID,
'||'        t.functionality as PERMISSION_NAME,
'||'        case
'||'         when t.operation = ''1'' then ''PERMISSION TO BE REMOVED FROM TARGET''
'||'         when t.operation = ''2'' then ''PERMISSION TO BE ADDED ON TARGET''
'||'        end as MESSAGE,
'||'        case
'||'         when t.trace_new = ''Changes in IDEAS Disabled!'' then ''''
'||'         else t.trace_new
'||'        end as TRACE,
'||'        t.process_id as RECONCILIATION_ID,
'||'        ''PERMISSION OUT OF SYNC'' as STATUS
'||'    from ev_targ t
'||'    full outer join #pmschema#.target tg on lower ( t.target ) = lower ( tg.name )
'||'    full outer join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'    full outer join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg and t.code = pwd.code
'||'    full outer join #pmschema#.person p on pwd.person = p.id
'||'    full outer join #pmschema#.organizational_unit o on p.organizational_unit = o.id
'||'    where t.operation in (''1'', ''2'')
'||'      and t.state = 2
'||'      and o.hierarchy = 1
'||'    union
'||'    -- IDEAS ACCOUNT - PERMISSIONS STATUS
'||'    select distinct tg.name as TARGET,
'||'            p.name as NAME,
'||'            p.surname as SURNAME,
'||'            ou.name as OU_NAME,
'||'            ou.code as OU_CODE,
'||'            pwd.code as ACCOUNT_USERID,
'||'            ent.name as PERMISSION_NAME,
'||'            '''' as MESSAGE,
'||'            '''' as TRACE,
'||'            '''' as RECONCILIATION_ID,
'||'            ''IN SYNC'' as STATUS
'||'    from #pmschema#.target tg
'||'    inner join #pmschema#.pwdcfg pcfg on tg.pwdcfg = pcfg.id
'||'    inner join #pmschema#.pwdmanagement pwd on pcfg.id = pwd.pwdcfg
'||'    inner join #pmschema#.person p on pwd.person = p.id
'||'    inner join #pmschema#.application app on tg.id = app.target
'||'    inner join #pmschema#.organizational_unit ou on p.organizational_unit = ou.id
'||'    inner join #pmschema#.employment emp on p.id = emp.person
'||'    inner join #pmschema#.entitlement_flat_hier efh on emp.entitlement = efh.parent and efh.child_application = app.id and efh.child_int_type = 1
'||'    inner join #pmschema#.entitlement ent on efh.child = ent.id and efh.child_application = ent.application
'||'    where lower ( tg.name ) = lower ( ''#target_name#'' )
'||'      and ou.hierarchy = 1
'||'      and ou.hierarchy = emp.hierarchy
'||') vgtab
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );

    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/

commit;