declare

  cursor1            sys_refcursor;
  cursor2            sys_refcursor;
  cursor3            sys_refcursor;
  
  repository_id      numeric(16);
  
  column_name        varchar(256);
  lookup_name        varchar(256);
  
  lookup_value       varchar(256);
  lookup_techvalue   varchar(256);
  
  stmt               varchar(256);

begin
  
  --BEGIN 1
  open cursor1 for
    select
      id
    from
      repository
    where
      enable = 0;

  loop
    fetch cursor1 into repository_id;
    exit when cursor1%notfound;
    
    --BEGIN 2
    open cursor2 for
      select
        name, lookup
      from
        externalmapping
      where
        repository = repository_id
        and lookup_type = 1;

    loop
    fetch cursor2 into column_name, lookup_name;
    exit when cursor2%notfound;
    
      --BEGIN 3
      open cursor3 for
        select
          value, int_value
        from
          service_attribute_lookup
        where
          name = lookup_name
          and value is not null
          and int_value is not null;

      loop
      fetch cursor3 into lookup_value, lookup_techvalue;
      exit when cursor3%notfound;
     
        --BEGIN 4
        stmt := 'update user_erc set ' || column_name || ' = ''' || lookup_techvalue || ''' where ' || column_name || ' = ''' || lookup_value || '''';
        --DBMS_OUTPUT.PUT_LINE(stmt);
        execute immediate(stmt);
        --END 4
        
      end loop;
      close cursor3;
      --END 3
    
    end loop;
    close cursor2;
    --END 2
    
  end loop;
  close cursor1;
  --END 1

  commit;
  
end;
/
