declare
  val NUMBER;
  address varchar2(256) := 'urn:ibm:idbrokerage:params:scim:schemas:extension:OracleAdapterAccount:2.0:User';
  def_lob     clob;
begin
  def_lob := '{
"id":"urn:ibm:idbrokerage:params:scim:schemas:extension:OracleAdapterAccount:2.0:User",
"name":"CustomUserExtension",
"description":"Security adapter view of a user",
"attributes":[
{"name":"eruid","type":"string","multiValued":false,"description":"A identifier used to uniquely identify a user","required":true,"caseExact":false,"mutability":"immutable","returned":"default","uniqueness":"server","specialFlags":"sys"},
{"name":"erpassword","type":"string","multiValued":false,"description":"A password used to authenticate a user.","required":false,"caseExact":true,"mutability":"writeOnly","returned":"never","uniqueness":"none","specialFlags":"secret"},
{"name":"eraccountstatus","type":"integer","multiValued":false,"description":"An identifier used to indicate if the account is active(0) or suspended(1).","required":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none","canonicalValues":[0,1]},
{"name":"erLastAccessDate","type":"dateTime","multiValued":false,"description":"Last Access Date","required":false,"mutability":"readOnly","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraAccountStatusStr","type":"string","multiValued":false,"description":"AccountStatus","required":false,"caseExact":false,"mutability":"readOnly","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraAuthenticationType","type":"string","multiValued":false,"description":"Specifies how the user will be authenticated by Oracle.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none","canonicalValues":["LOCAL","EXTERNAL","GLOBAL"]},
{"name":"erOraContainer","type":"string","multiValued":false,"description":"Specifies the container clause value to be used for granting privileges.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none","canonicalValues":["","ALL","CURRENT"]},
{"name":"erOraCreateDate","type":"string","multiValued":false,"description":"Create Date","required":false,"caseExact":false,"mutability":"readOnly","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraDefaultTableSpace","type":"string","multiValued":false,"description":"Name of the default tablespace.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraDefRsrcConsumerGroup","type":"string","multiValued":false,"description":"The default/initial resource consumer groups for the user.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraExpirePwd","type":"boolean","multiValued":false,"description":"If true, set the password to expire.","required":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraExpiryDate","type":"string","multiValued":false,"description":"Expiry Date","required":false,"caseExact":false,"mutability":"readOnly","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraGlobalName","type":"string","multiValued":false,"description":"An external name that identifies the user.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraLockDate","type":"string","multiValued":false,"description":"Lock Date","required":false,"caseExact":false,"mutability":"readOnly","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraNonDefRole","type":"string","multiValued":true,"description":"Non Default Database Roles","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraPassLastChgDate","type":"string","multiValued":false,"description":"Last password change date of the user.","required":false,"caseExact":false,"mutability":"readOnly","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraProfile","type":"string","multiValued":false,"description":"Profile name assigned to the account.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraProxyToUsers","type":"string","multiValued":true,"description":"Become Proxy user to specified users.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraProxyUsers","type":"string","multiValued":true,"description":"List of proxy users","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraRole","type":"string","multiValued":true,"description":"Database roles assigned to the account.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraRsrcConsumerGroup","type":"string","multiValued":true,"description":"List of resource consumer groups the user can switch to.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraSysPriv","type":"string","multiValued":true,"description":"The System Privilege assigned to the user.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"group"},
{"name":"erOraTblSpcQuota","type":"string","multiValued":true,"description":"Maximum space allowed on a tablespace.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"},
{"name":"erOraTemporaryTableSpace","type":"string","multiValued":false,"description":"Name of the temporary tablespace.","required":false,"caseExact":false,"mutability":"readWrite","returned":"default","uniqueness":"none","specialFlags":"none"}
],
"meta":{"resourceType":"Schema","created":"20181225114338Z","lastModified":"20181225114338Z"}}';
BEGIN
   select instr( definition, '||') into val FROM ib_target_resource_schema_ext WHERE urn=address;
    if val>0 then
           update ib_target_resource_schema_ext set definition=def_lob where urn=address;
    end if;
    EXCEPTION
     WHEN NO_DATA_FOUND THEN
       RETURN;
END;
end;
/
commit;
 