declare
  rq_id            number(16);
  rq_name          varchar2(256) := 'Access request history DB';
  rqd              clob;
  counter          number(16);

begin


  rqd := 'select
'||'  t.request_type as request_type,
'||'  t.request_status as request_status,
'||'  count(1) as request_count
'||'from
'||'(
'||'  select
'||'    case
'||'      when req.req_type = 4 then ''Admin Access Change''
'||'      when req.req_type = 5 then ''User Access Change''
'||'      when req.req_type = 6 then ''Role Assign''
'||'      when req.req_type = 8 then ''Role Removal''
'||'      when req.req_type = 9 then ''Role Renewal''
'||'      when req.req_type = 10 then ''Delegation Assign''
'||'      when req.req_type = 12 then ''Delegation Removal''
'||'      when req.req_type = 13 then ''Delegation Change''
'||'      when req.req_type = 18 then ''Password Reset''
'||'      when req.req_type = 19 then ''Password Change''
'||'      when req.req_type = 32 then ''Account Suspend''
'||'      when req.req_type = 33 then ''Account Restore''
'||'      when req.req_type = 58 then ''Account Management''
'||'      when req.req_type = 61 then ''Delegation Renewal''
'||'      when req.req_type = 70 then ''Entitlement Management''
'||'      when req.req_type = 71 then ''Insert User''
'||'      when req.req_type = 72 then ''Update User''
'||'      when req.req_type = 73 then ''User Delete''
'||'      when req.req_type = 77 then ''Entitlement Create''
'||'      when req.req_type = 78 then ''Entitlement Update''
'||'      when req.req_type = 79 then ''Entitlement Delete''
'||'      when req.req_type = 80 then ''User Management''
'||'      when req.req_type = 81 then ''Account Create''
'||'      when req.req_type = 82 then ''Account Update''
'||'      when req.req_type = 83 then ''Account Delete''
'||'      else cast ( req.req_type as varchar(256) )
'||'    end request_type,
'||'    case
'||'      when req.req_status = ''2'' then ''Authorizable''
'||'      when req.req_status = ''3'' then ''Approved''
'||'      when req.req_status = ''4'' then ''Suspended''
'||'      when req.req_status = ''5'' then ''Rejected''
'||'      when req.req_status = ''6'' then ''Performed''
'||'      when req.req_status = ''7'' then ''Completed''
'||'      when req.req_status = ''8'' then ''Failed Completion''
'||'      when req.req_status = ''9'' then ''Pending ''
'||'      when req.req_status = ''10'' then ''Escalation''
'||'      when req.req_status = ''12'' then ''Partially Authorizable''
'||'      when req.req_status = ''13'' then ''Partially Approved''
'||'      when req.req_status = ''14'' then ''Partially Executed''
'||'      when req.req_status = ''15'' then ''Partially Completed''
'||'      when req.req_status = ''19'' then ''Incompatibility''
'||'      when req.req_status = ''30'' then ''Terminated pending confirmation''
'||'      when req.req_status = ''31'' then ''Partially Terminated''
'||'      else cast ( req.req_status as varchar(256) )
'||'    end request_status
'||'  from
'||'    #pmschema#.person                             p,
'||'    #swimschema#.request                            req
'||'  where p.s_user = req.beneficiary
'||'    and lower ( p.code ) like lower (''#ideas_userlogged#'')
'||'    and req.parent is not null
'||') t
'||'group by t.request_type, t.request_status
';

  select count(1) into counter from r_query t where lower ( t.name ) = lower ( rq_name );
  if ( counter = 1 ) then
    select t.id into rq_id from r_query t where lower ( t.name ) = lower ( rq_name );
    update r_query_data set query = rqd where r_query = rq_id;
  end if;
  
end;
/
commit;
