alter trigger trg_person_service_to_eventpm disable;

declare
  pwdmgmt_id      number(16);
  ps_id           number(16);
  ps_profile      number(16);
  ps_person       number(16);
  cur_pwdmgmt     sys_refcursor;
  cur_ps          sys_refcursor;

begin
  open cur_ps for select ps.id, ps.profile, ps.person from person_service ps where ps.pwdmanagement is null;
  loop
    fetch cur_ps into ps_id, ps_profile, ps_person;
    exit when cur_ps%NOTFOUND;
    open cur_pwdmgmt for
	select pwdmgmt.id from pwdmanagement pwdmgmt, application app, target tar, entitlement ent where pwdmgmt.is_default = 1 and pwdmgmt.person = ps_person and pwdmgmt.pwdcfg = tar.pwdcfg and app.target = tar.id and app.id = ent.application and ent.id = ps_profile;
    loop
      fetch cur_pwdmgmt into pwdmgmt_id;
      exit when cur_pwdmgmt%NOTFOUND;
      update person_service perserv set pwdmanagement = pwdmgmt_id where perserv.id = ps_id;
    end loop;
	close cur_pwdmgmt;
  end loop;
  close cur_ps;
end;
/
commit;

alter trigger trg_person_service_to_eventpm enable;
